'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _defaultStyles = require('./defaultStyles');

var _recompose = require('recompose');

var _sharedHandlers = require('./sharedHandlers');

var _ModalDialog = require('./ModalDialog');

var _ModalDialog2 = _interopRequireDefault(_ModalDialog);

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _ResizeListener = require('./ResizeListener');

var _ResizeListener2 = _interopRequireDefault(_ResizeListener);

var _Step = require('./Step');

var _Step2 = _interopRequireDefault(_Step);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MultiplePageModal = function MultiplePageModal(_ref) {
  var onCloseModal = _ref.onCloseModal,
      onOpenModal = _ref.onOpenModal,
      setExternalModalIsOpenTo = _ref.setExternalModalIsOpenTo,
      externalModalIsOpenTo = _ref.externalModalIsOpenTo,
      useStyleTemplate = _ref.useStyleTemplate,
      pageNavigationButtonsAreDisabled = _ref.pageNavigationButtonsAreDisabled,
      renderTrigger = _ref.renderTrigger,
      onMount = _ref.onMount,
      onUnmount = _ref.onUnmount,
      noCloseModalButton = _ref.noCloseModalButton,
      pages = _ref.pages,
      steps = _ref.steps,
      _ref$stepStyleConfig = _ref.stepStyleConfig,
      stepStyleConfig = _ref$stepStyleConfig === undefined ? {
    shared: {
      position: 'relative',
      display: 'flex',
      alignItems: 'center',
      cursor: 'pointer',
      height: '6rem',
      padding: '1rem 2rem'
    },
    inactive: {
      background: '#fff'
    },
    active: {
      background: '#eee'
    }
  } : _ref$stepStyleConfig,
      isTesting = _ref.isTesting,
      _ref$backgroundProps = _ref.backgroundProps,
      backgroundProps = _ref$backgroundProps === undefined ? {
    className: '',
    style: {}
  } : _ref$backgroundProps,
      renderNextButton = _ref.renderNextButton,
      renderBackButton = _ref.renderBackButton,
      customStyleTemplate = _ref.customStyleTemplate;

  var styleTemplate = customStyleTemplate ? customStyleTemplate : useStyleTemplate ? _defaultStyles.modalStyleTemplates[useStyleTemplate] : {};

  var renderPageNavigationButtons = function renderPageNavigationButtons(_ref2) {
    var currentPage = _ref2.currentPage,
        length = _ref2.length,
        getButtonProps = _ref2.getButtonProps;

    var renderNext = function renderNext() {
      return renderNextButton({
        getButtonProps: getButtonProps,
        disabled: pageNavigationButtonsAreDisabled,
        goToNextPage: goToNextPage
      });
    };
    var renderBack = function renderBack() {
      return renderBackButton({ getButtonProps: getButtonProps, goToPreviousPage: goToPreviousPage });
    };
    if (currentPage === 0) {
      return renderNext();
    }
    if (currentPage === length - 1) {
      return renderBack();
    } else {
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        renderBack(),
        renderNext()
      );
    }
  };

  var _useReducer = (0, _react.useReducer)(function (state, newState) {
    return (0, _extends3.default)({}, state, newState);
  }, {
    modalIsOpen: false,
    currentPage: 0
  }),
      _useReducer2 = (0, _slicedToArray3.default)(_useReducer, 2),
      state = _useReducer2[0],
      setState = _useReducer2[1];

  var closeModal = function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return setState({ modalIsOpen: false });

            case 2:
              setExternalModalIsOpenTo && setExternalModalIsOpenTo(false);
              onCloseModal && onCloseModal();

            case 4:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function closeModal() {
      return _ref3.apply(this, arguments);
    };
  }();

  var setCurrentPageTo = function setCurrentPageTo(n) {
    setState({ currentPage: n });
  };
  var setModalIsOpenTo = function setModalIsOpenTo(bool) {
    setState({ modalIsOpen: bool });
  };
  var openModal = function () {
    var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return setState({ modalIsOpen: true });

            case 2:
              setExternalModalIsOpenTo && setExternalModalIsOpenTo(true);
              onOpenModal && onOpenModal();

            case 4:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function openModal() {
      return _ref4.apply(this, arguments);
    };
  }();

  var toggleModalIsOpen = function () {
    var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return setState({ modalIsOpen: !modalIsOpen });

            case 2:
              _context3.t0 = setExternalModalIsOpenTo;

              if (!_context3.t0) {
                _context3.next = 6;
                break;
              }

              _context3.next = 6;
              return setExternalModalIsOpenTo(externalModalIsOpen);

            case 6:
              _context3.t1 = onOpenModal && modalIsOpen;

              if (!_context3.t1) {
                _context3.next = 10;
                break;
              }

              _context3.next = 10;
              return onOpenModal();

            case 10:
              _context3.t2 = onCloseModal && !modalIsOpen;

              if (!_context3.t2) {
                _context3.next = 14;
                break;
              }

              _context3.next = 14;
              return onCloseModal();

            case 14:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined);
    }));

    return function toggleModalIsOpen() {
      return _ref5.apply(this, arguments);
    };
  }();

  var goToNextPage = function goToNextPage() {
    setState({
      currentPage: currentPage === pages.length - 1 ? currentPage : currentPage + 1
    });
  };
  var goToPreviousPage = function goToPreviousPage() {
    setState({ currentPage: currentPage === 0 ? currentPage : currentPage - 1 });
  };

  var renderSteps = function renderSteps(currentPageNumber, steps) {
    //const belowThreshold = window.innerWidth < 300 * steps.length
    //console.log(belowThreshold)

    return _react2.default.createElement(
      _ResizeListener2.default,
      { threshold: 300 * steps.length },
      function (_ref6) {
        var alignHorizontally = _ref6.isOverThreshold;
        return _react2.default.createElement(
          'div',
          {
            className: 'multiplepagemodal__steps',
            style: {
              display: 'flex',
              width: '100%',
              flexDirection: alignHorizontally ? 'row' : 'column'
            }
          },
          steps.map(function (_ref7, stepNumber) {
            var renderStep = _ref7.renderStep;

            return _react2.default.createElement(_Step2.default, {
              onClick: function onClick() {
                return setCurrentPageTo(stepNumber);
              },
              alignHorizontally: alignHorizontally,
              stepStyleConfig: stepStyleConfig,
              key: stepNumber,
              isActive: currentPageNumber === stepNumber,
              isDisabled: stepNumber > currentPageNumber && pageNavigationButtonsAreDisabled,
              isComplete: currentPageNumber > stepNumber,
              isLast: stepNumber === steps.length - 1,
              renderStep: renderStep
            });
          })
        );
      }
    );
  };

  var getTriggerProps = function getTriggerProps() {
    var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick = _ref8.onClick,
        className = _ref8.className,
        props = (0, _objectWithoutProperties3.default)(_ref8, ['onClick', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        setModalIsOpenTo(true);
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__trigger ' + className : 'modal__trigger'

    }, props);
  };
  var getBackgroundProps = function getBackgroundProps() {
    var _ref9 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick2 = _ref9.onClick,
        style = _ref9.style,
        className = _ref9.className,
        props = (0, _objectWithoutProperties3.default)(_ref9, ['onClick', 'style', 'className']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        e.stopPropagation();
        setModalIsOpenTo(false);
        _onClick2 && _onClick2.apply(undefined, [e].concat(args));
      },
      className: className ? 'modal__background ' + className : 'modal__background',
      style: style
    }, props);
  };

  var currentPage = state.currentPage;


  return _react2.default.createElement(
    _react2.default.Fragment,
    null,
    renderTrigger && renderTrigger({
      modalIsOpen: state.modalIsOpen,
      toggleModalIsOpen: toggleModalIsOpen,
      getTriggerProps: getTriggerProps
    }),
    _react2.default.createElement(
      _RTGTransition2.default,
      { in: isTesting ? true : state.modalIsOpen },
      function (_ref10) {
        var transitionStyle = _ref10.style;
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getBackgroundProps({
            style: isTesting ? null : (0, _extends3.default)({}, transitionStyle, styleTemplate.background, backgroundProps.style),
            className: backgroundProps.className ? 'modal__background ' + backgroundProps.className : 'modal__background'
          })),
          pages.map(function (page, i) {
            return currentPage === i && _react2.default.createElement(_ModalDialog2.default, {
              useStyleTemplate: useStyleTemplate,
              customStyleTemplate: customStyleTemplate,
              setModalIsOpenTo: setModalIsOpenTo,
              onMount: onMount,
              onUnmount: onUnmount,
              closeModal: closeModal,
              key: currentPage,
              noCloseModalButton: isTesting ? true : noCloseModalButton,
              renderHeader: function renderHeader(_ref11) {
                var getHeaderProps = _ref11.getHeaderProps;
                return page.renderHeader ? page.renderHeader({
                  getHeaderProps: getHeaderProps,
                  renderSteps: renderSteps(currentPage, steps)
                }) : steps ? _react2.default.createElement(
                  'div',
                  getHeaderProps(),
                  renderSteps(currentPage, steps)
                ) : null;
              },

              renderButtons: function renderButtons(_ref12) {
                var getButtonProps = _ref12.getButtonProps,
                    getButtonsProps = _ref12.getButtonsProps;
                return page.renderButtons ? page.renderButtons({
                  getButtonProps: getButtonProps,
                  getButtonsProps: getButtonsProps,
                  renderPageNavigationButtons: renderPageNavigationButtons({
                    currentPage: currentPage,
                    length: pages.length,
                    getButtonProps: getButtonProps
                  })
                }) : _react2.default.createElement(
                  'div',
                  (0, _extends3.default)({}, getButtonsProps()),
                  renderPageNavigationButtons({
                    currentPage: i,
                    length: pages.length,
                    getButtonProps: getButtonProps
                  })
                );
              },

              renderBody: function renderBody(_ref13) {
                var getBodyProps = _ref13.getBodyProps;
                return page.renderBody ? page.renderBody({
                  getBodyProps: getBodyProps,
                  setCurrentPageTo: setCurrentPageTo,
                  toggleModalIsOpen: toggleModalIsOpen
                }) : _react2.default.createElement(
                  'div',
                  (0, _extends3.default)({}, getBodyProps()),
                  page.renderBody({ setCurrentPageTo: setCurrentPageTo, toggleModalIsOpen: toggleModalIsOpen })
                );
              }
            });
          })
        );
      }
    )
  );
}; // rearrange next/back buttons for ease of use


var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  noCloseModalButton: false,
  onCloseModal: function onCloseModal() {
    return null;
  },
  onOpenModal: function onOpenModal() {
    return null;
  },
  onMount: function onMount() {
    return null;
  },
  onUnmount: function onUnmount() {
    return null;
  },
  useStyleTemplate: 'default'
}),
//withState(`modalIsOpen`, `setModalIsOpenTo`, false),
//withState(`currentPage`, `setCurrentPageTo`, 0),
//withHandlers({
//  goToNextPage: ({ setCurrentPageTo, pages }) => () => {
//    setCurrentPageTo(n => (n === pages.length - 1 ? n : n + 1))
//  },
//  goToPreviousPage: ({ setCurrentPageTo }) => () => {
//    setCurrentPageTo(n => (n === 0 ? n : n - 1))
//  },
//}),

(0, _recompose.setPropTypes)({
  pageNavigationButtonsAreDisabled: _propTypes2.default.bool,
  pages: _propTypes2.default.array.isRequired,
  steps: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    renderStep: _propTypes2.default.func.isRequired
  })).isRequired,
  noCloseModalButton: _propTypes2.default.bool,
  modalIsOpen: _propTypes2.default.bool.isRequired,
  currentPage: _propTypes2.default.number.isRequired,
  toggleModalIsOpen: _propTypes2.default.func.isRequired,
  setCurrentPageTo: _propTypes2.default.func.isRequired,
  goToNextPage: _propTypes2.default.func.isRequired,
  goToPreviousPage: _propTypes2.default.func.isRequired
}));

MultiplePageModal.defaultProps = {
  noCloseModalButton: false,
  onCloseModal: function onCloseModal() {
    return null;
  },
  onOpenModal: function onOpenModal() {
    return null;
  },
  onMount: function onMount() {
    return null;
  },
  onUnmount: function onUnmount() {
    return null;
  },
  useStyleTemplate: 'default',
  backgroundProps: {},
  pageNavigationButtonsAreDisabled: false,
  renderNextButton: function renderNextButton(_ref14) {
    var getButtonProps = _ref14.getButtonProps,
        goToNextPage = _ref14.goToNextPage,
        disabled = _ref14.disabled;
    return _react2.default.createElement(
      _Button2.default,
      (0, _extends3.default)({}, getButtonProps({ onClick: goToNextPage }), { disabled: disabled }),
      'NEXT'
    );
  },
  renderBackButton: function renderBackButton(_ref15) {
    var getButtonProps = _ref15.getButtonProps,
        goToPreviousPage = _ref15.goToPreviousPage;
    return _react2.default.createElement(
      _Button2.default,
      (0, _extends3.default)({}, getButtonProps({ onClick: goToPreviousPage })),
      'BACK'
    );
  }
};

exports.default = enhance(MultiplePageModal);